﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.IO;

namespace test_ASRA_COM
{
    class Program
    {
        static void Main(string[] args)
        {
            ASRA_COMLib.ASRAClass myClass = new ASRA_COMLib.ASRAClass();    // Set up COM

            // get the absolute path, which is necessary for passing path to functions in COM
            string exeFilePath =
                Path.GetDirectoryName(
                System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase).Replace("file:\\", "");


            string candidateList = exeFilePath + "\\candidateList_EN.txt";
            string wavFilename;
            string sentence;
            double recordTime = 4;
            int count;
            FileStream fs;
            StreamReader sr;

            
			// Testing Function "RecordAndAssess"

            sentence = "where are you going";
            Console.WriteLine("Test RecordAndAssess :");
            Console.WriteLine("Press enter to start record, and read「" + sentence + "」in " + recordTime + " seconds. The program will assess it's score.");
            Console.ReadLine();
            Console.WriteLine("Recording...");
            Console.WriteLine();
            Console.WriteLine("The score is: " + myClass.RecordAndAssess(recordTime, sentence));
            Console.WriteLine();
            Console.WriteLine("Press Enter to continue...");
            Console.ReadLine();

            // Testing Function "RecordAndRecog"

            Console.Clear();
            Console.WriteLine("Test RecordAndRecog :");
            Console.WriteLine("Specified candidate list file: " + candidateList);
            Console.WriteLine("Candidate sentence: ");
            fs = new FileStream(candidateList, FileMode.Open);
            sr = new StreamReader(fs, Encoding.GetEncoding("big5"));
            count = 1;
            while (!sr.EndOfStream)
                Console.WriteLine((count++) + ". " + sr.ReadLine());
            sr.Close();
            fs.Close();
            Console.WriteLine("Press enter to start record, and read one of the candidated sentence in " + recordTime + " seconds. The program will recognize it.");
            Console.ReadLine();
            Console.WriteLine("Recording...");
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("The result is: " + myClass.RecordAndRecog(recordTime, candidateList));
            Console.WriteLine();
            Console.WriteLine("Press Enter to continue...");
            Console.ReadLine();            
            
            // Testing Function "Assess"

            Console.Clear();
            wavFilename = exeFilePath + "\\you_took_me_by_surprise.wav";
            sentence = "you took me by surprise";
            Console.WriteLine("Test Assess :");
            Console.WriteLine("File to be assessed: " + wavFilename);
            Console.WriteLine("Sentence: " + sentence);
            Console.WriteLine("Press Enter to start...");
            Console.ReadLine();
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("The score of " + wavFilename + " is: " + myClass.Assess(wavFilename, sentence));
            Console.WriteLine();
            Console.WriteLine("Press Enter to continue...");
            Console.ReadLine();
            
            // Testing Function "Recog"

            Console.Clear();
            wavFilename = exeFilePath + "\\are_you_having_fun_talk_to_me.wav";
            Console.WriteLine("Test Recog :");
            Console.WriteLine("The program will recognize according specified wave file and candidate sentence.");
            Console.WriteLine("Specified wav file: " + wavFilename);
            Console.WriteLine("Specified candidate list file: " + candidateList);
            Console.WriteLine("Candidate sentence: ");
            fs = new FileStream(candidateList, FileMode.Open);
            sr = new StreamReader(fs, Encoding.GetEncoding("big5"));
            count = 1;
            while (!sr.EndOfStream)
                Console.WriteLine((count++) + ". " + sr.ReadLine());
            sr.Close();
            fs.Close();
            Console.WriteLine("Press Enter to start...");
            Console.ReadLine();
            Console.WriteLine("The result of " + wavFilename + " is: " + myClass.Recog(wavFilename, candidateList));
            Console.WriteLine();
            Console.WriteLine("Press Enter to continue...");
            Console.ReadLine();
            
            // 切換成中文
            myClass.SwitchLanguage(1);
            candidateList = exeFilePath + "\\candidateList_CH.txt";

            // 測試 RecordAndAssess 函式

            sentence = "清華大學資訊工程系";
            Console.WriteLine("測試 RecordAndAssess 函式:");
            Console.WriteLine("按下 enter 後開始錄音，請在 " + recordTime + " 秒內念出「" + sentence + "」，程式會進行評分。");
            Console.ReadLine();
            Console.WriteLine("正在進行錄音...");
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("您的得分: " + myClass.RecordAndAssess(recordTime, sentence));
            Console.WriteLine();
            Console.WriteLine("按下 enter 繼續...");
            Console.ReadLine();

            // 測試 RecordAndRecog 函式

            Console.Clear();
            Console.WriteLine("測試 RecordAndRecog 函式:");
            Console.WriteLine("指定的候選句子清單檔案: " + candidateList);
            Console.WriteLine("候選句子:");
            fs = new FileStream(candidateList, FileMode.Open);
            sr = new StreamReader(fs, Encoding.GetEncoding("big5"));
            count = 1;
            while (!sr.EndOfStream)
                Console.WriteLine((count++) + ". " + sr.ReadLine());
            sr.Close();
            fs.Close();
            Console.WriteLine("按下 enter 後開始錄音，請在 " + recordTime + " 秒內念出上列句子中的一句，程式會進行辨識。");
            Console.ReadLine();
            Console.WriteLine("正在進行錄音...");
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("您剛剛念的是: " + myClass.RecordAndRecog(recordTime, candidateList));
            Console.WriteLine();
            Console.WriteLine("按下 enter 繼續...");
            Console.ReadLine();

            // 測試 Assess 函式

            Console.Clear();
            wavFilename = exeFilePath + "\\天氣熱打哈欠.wav";
            sentence = "天氣熱打哈欠";
            Console.WriteLine("測試 Assess 函式:");
            Console.WriteLine("程式會根據指定的 wav 檔案與指定的句子進行評分。");
            Console.WriteLine("指定的 wav 檔案: " + wavFilename);
            Console.WriteLine("指定的句子: " + sentence);
            Console.WriteLine("按下 enter 開始評分...");
            Console.ReadLine();
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine(wavFilename + " 的得分: " + myClass.Assess(wavFilename, sentence));
            Console.WriteLine();
            Console.WriteLine("按下 enter 繼續...");
            Console.ReadLine();

            // 測試 Recog 函式

            Console.Clear();
            wavFilename = exeFilePath + "\\主人下馬客在船.wav";
            Console.WriteLine("測試 Recog 函式:");
            Console.WriteLine("程式會根據指定的 wav 檔案與指定的候選句子清單進行辨識。");
            Console.WriteLine("指定的 wav 檔案: " + wavFilename);
            Console.WriteLine("指定的候選句子清單檔案: " + candidateList);
            Console.WriteLine("候選句子:");
            fs = new FileStream(candidateList, FileMode.Open);
            sr = new StreamReader(fs, Encoding.GetEncoding("big5"));
            count = 1;
            while (!sr.EndOfStream)
                Console.WriteLine((count++) + ". " + sr.ReadLine());
            sr.Close();
            fs.Close();
            Console.WriteLine("按下 enter 後開始辨識...");
            Console.ReadLine();
            Console.WriteLine(wavFilename + "的內容是: " + myClass.Recog(wavFilename, candidateList));
            Console.WriteLine();
            Console.WriteLine("按下 enter 繼續...");
            Console.ReadLine();

         }
    }
}